diff -Nru a/drivers/acpi/utilities/utmisc.c b/drivers/acpi/utilities/utmisc.c
--- a/drivers/acpi/utilities/utmisc.c	2004-11-10 23:41:02 -05:00
+++ b/drivers/acpi/utilities/utmisc.c	2004-11-10 23:41:02 -05:00
@@ -356,16 +356,15 @@
  * FUNCTION:    acpi_ut_strtoul64
  *
  * PARAMETERS:  String          - Null terminated string
- *              Terminater      - Where a pointer to the terminating byte is returned
- *              Base            - Radix of the string
+ *              Base            - Radix of the string: 10, 16, or ACPI_ANY_BASE
+ *              ret_integer     - Where the converted integer is returned
  *
- * RETURN:      Converted value
+ * RETURN:      Status and Converted value
  *
  * DESCRIPTION: Convert a string into an unsigned value.
+ *              NOTE: Does not support Octal strings, not needed.
  *
  ******************************************************************************/
-#define NEGATIVE    1
-#define POSITIVE    0
 
 acpi_status
 acpi_ut_strtoul64 (
@@ -373,50 +372,40 @@
 	u32                             base,
 	acpi_integer                    *ret_integer)
 {
-	u32                             index;
+	u32                             this_digit;
 	acpi_integer                    return_value = 0;
-	acpi_status                     status = AE_OK;
-	acpi_integer                    dividend;
 	acpi_integer                    quotient;
 
 
-	*ret_integer = 0;
+	ACPI_FUNCTION_TRACE ("ut_stroul64");
+
 
 	switch (base) {
-	case 0:
-	case 8:
+	case ACPI_ANY_BASE:
 	case 10:
 	case 16:
 		break;
 
 	default:
-		/*
-		 * The specified Base parameter is not in the domain of
-		 * this function:
-		 */
-		return (AE_BAD_PARAMETER);
+		/* Invalid Base */
+		return_ACPI_STATUS (AE_BAD_PARAMETER);
 	}
 
-	/*
-	 * skip over any white space in the buffer:
-	 */
+	/* Skip over any white space in the buffer */
+
 	while (ACPI_IS_SPACE (*string) || *string == '\t') {
 		++string;
 	}
 
 	/*
 	 * If the input parameter Base is zero, then we need to
-	 * determine if it is octal, decimal, or hexadecimal:
+	 * determine if it is decimal or hexadecimal:
 	 */
 	if (base == 0) {
-		if (*string == '0') {
-			if (ACPI_TOLOWER (*(++string)) == 'x') {
-				base = 16;
-				++string;
-			}
-			else {
-				base = 8;
-			}
+		if ((*string == '0') &&
+			(ACPI_TOLOWER (*(++string)) == 'x')) {
+			base = 16;
+			++string;
 		}
 		else {
 			base = 10;
@@ -424,76 +413,67 @@
 	}
 
 	/*
-	 * For octal and hexadecimal bases, skip over the leading
+	 * For hexadecimal base, skip over the leading
 	 * 0 or 0x, if they are present.
 	 */
-	if (base == 8 && *string == '0') {
-		string++;
-	}
-
 	if (base == 16 &&
 		*string == '0' &&
 		ACPI_TOLOWER (*(++string)) == 'x') {
 		string++;
 	}
 
-	/* Main loop: convert the string to an unsigned long */
+	/* Main loop: convert the string to a 64-bit integer */
 
 	while (*string) {
 		if (ACPI_IS_DIGIT (*string)) {
-			index = ((u8) *string) - '0';
+			/* Convert ASCII 0-9 to Decimal value */
+
+			this_digit = ((u8) *string) - '0';
 		}
 		else {
-			index = (u8) ACPI_TOUPPER (*string);
-			if (ACPI_IS_UPPER ((char) index)) {
-				index = index - 'A' + 10;
+			this_digit = (u8) ACPI_TOUPPER (*string);
+			if (ACPI_IS_UPPER ((char) this_digit)) {
+				/* Convert ASCII Hex char to value */
+
+				this_digit = this_digit - 'A' + 10;
 			}
 			else {
 				goto error_exit;
 			}
 		}
 
-		if (index >= base) {
+		/* Check to see if digit is out of range */
+
+		if (this_digit >= base) {
 			goto error_exit;
 		}
 
-		/* Check to see if value is out of range: */
+		/* Divide the digit into the correct position */
 
-		dividend = ACPI_INTEGER_MAX - (acpi_integer) index;
-		(void) acpi_ut_short_divide (&dividend, base, &quotient, NULL);
+		(void) acpi_ut_short_divide ((ACPI_INTEGER_MAX - (acpi_integer) this_digit),
+				 base, &quotient, NULL);
 		if (return_value > quotient) {
 			goto error_exit;
 		}
 
 		return_value *= base;
-		return_value += index;
+		return_value += this_digit;
 		++string;
 	}
 
 	*ret_integer = return_value;
-	return (status);
+	return_ACPI_STATUS (AE_OK);
 
 
 error_exit:
-	switch (base) {
-	case 8:
-		status = AE_BAD_OCTAL_CONSTANT;
-		break;
-
-	case 10:
-		status = AE_BAD_DECIMAL_CONSTANT;
-		break;
-
-	case 16:
-		status = AE_BAD_HEX_CONSTANT;
-		break;
+	/* Base was set/validated above */
 
-	default:
-		/* Base validated above */
-		break;
+	if (base == 10) {
+		return_ACPI_STATUS (AE_BAD_DECIMAL_CONSTANT);
+	}
+	else {
+		return_ACPI_STATUS (AE_BAD_HEX_CONSTANT);
 	}
-
-	return (status);
 }
 
 
diff -Nru a/drivers/acpi/utilities/utobject.c b/drivers/acpi/utilities/utobject.c
--- a/drivers/acpi/utilities/utobject.c	2004-11-10 23:41:02 -05:00
+++ b/drivers/acpi/utilities/utobject.c	2004-11-10 23:41:02 -05:00
@@ -155,9 +155,8 @@
 	ACPI_FUNCTION_TRACE_U32 ("ut_create_buffer_object", buffer_size);
 
 
-	/*
-	 * Create a new Buffer object
-	 */
+	/* Create a new Buffer object */
+
 	buffer_desc = acpi_ut_create_internal_object (ACPI_TYPE_BUFFER);
 	if (!buffer_desc) {
 		return_PTR (NULL);
@@ -186,6 +185,61 @@
 	/* Return the new buffer descriptor */
 
 	return_PTR (buffer_desc);
+}
+
+
+/*******************************************************************************
+ *
+ * FUNCTION:    acpi_ut_create_string_object
+ *
+ * PARAMETERS:  string_size            - Size of string to be created.  Does not
+ *                                       include NULL terminator, this is added
+ *                                       automatically.
+ *
+ * RETURN:      Pointer to a new String object
+ *
+ * DESCRIPTION: Create a fully initialized string object
+ *
+ ******************************************************************************/
+
+union acpi_operand_object *
+acpi_ut_create_string_object (
+	acpi_size                       string_size)
+{
+	union acpi_operand_object       *string_desc;
+	char                            *string;
+
+
+	ACPI_FUNCTION_TRACE_U32 ("ut_create_string_object", string_size);
+
+
+	/* Create a new String object */
+
+	string_desc = acpi_ut_create_internal_object (ACPI_TYPE_STRING);
+	if (!string_desc) {
+		return_PTR (NULL);
+	}
+
+	/*
+	 * Allocate the actual string buffer -- (Size + 1) for NULL terminator.
+	 * NOTE: Zero-length strings are NULL terminated
+	 */
+	string = ACPI_MEM_CALLOCATE (string_size + 1);
+	if (!string) {
+		ACPI_REPORT_ERROR (("create_string: could not allocate size %X\n",
+			(u32) string_size));
+		acpi_ut_remove_reference (string_desc);
+		return_PTR (NULL);
+	}
+
+	/* Complete string object initialization */
+
+	string_desc->string.pointer = string;
+	string_desc->string.length = (u32) string_size;
+
+	/* Return the new string descriptor */
+
+	return_PTR (string_desc);
 }
 
 
diff -Nru a/drivers/acpi/utils.c b/drivers/acpi/utils.c
--- a/drivers/acpi/utils.c	2004-11-10 23:41:02 -05:00
+++ b/drivers/acpi/utils.c	2004-11-10 23:41:02 -05:00
@@ -373,7 +373,7 @@
 	}
 
 	if (package->package.count > ACPI_MAX_HANDLES) {
-		return AE_NO_MEMORY;
+		return_ACPI_STATUS(AE_NO_MEMORY);
 	}
 	list->count = package->package.count;
 
